// wsClientDlg.h : Declaration of the CwsClientDlg

#ifndef __WSCLIENTDLG_H_
#define __WSCLIENTDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include <wininet.h>

// wsDmur.ocx
#import "C:\\Documents and Settings\\Michael\\My Documents\\MyApp\\Cpp\\FTPclient\\wsDmur\\Release\\wsDmur.ocx" raw_native_types, no_namespace, named_guids
//#import "C:\\Documents and Settings\\Michael\\ \\App\\Cpp\\wsDmur\\Release\\wsDmur.ocx" raw_native_types, no_namespace, named_guids  

//Mscomctl.ocx
#pragma warning(disable: 4146)
#import "C:\\WINNT\\system32\\Mscomctl.ocx" raw_native_types, no_namespace, named_guids
#pragma warning(default: 4146)

#define UM_ERROR	(WM_USER+100)

////////////////////////////////////////////////////////////
// This definitions are necessary for changing 
// according to your settings (see in ReadMe.txt)
//
#define USE_INRANET				TRUE	// (TRUE - intranet / FALSE - internet)
#define DEFAULT_PROXY			FALSE	// (FALSE - no any http-proxy / TRUE - through http-proxy)

#define USE_PROXY_AUTHORIZATION	FALSE  // TRUE in case DEFAULT_PROXY TRUE
#define UID_PWD					_T("dWlkOnB3ZA==") //<- proxyUID:proxyPWD (in Base64 coding) 

// Default URL GET
#if USE_INRANET 
	#define DEFAULT_REMOTEHOST	_T("localhost")
	#define LOCALFILE			_T("test.zip")
	#define DEFAULT_CMDTOSEND	_T("GET http://localhost/downloads/test.zip")
#else
	#define DEFAULT_REMOTEHOST	_T("narod.ru")
	#define LOCALFILE			_T("wsdmur.zip")
	#define DEFAULT_CMDTOSEND	_T("GET http://vfpdev.narod.ru/download/wsdmur.zip")
#endif

#define LOGFILE				_T("wsLog.log")	// Name log-file, if empty string - no any log-file
#define CONTINUDOWNLOAD		FALSE			// Continue download manually (after reconnect) (through the telephone as example), FALSE - always as new download
#define MAXRECOVERYCONNECT	10				// if 0 stop downloading on any error
#define WAITRECOVERYCONNECT	5000			// (in milliseconds)

// (see also resorce IDD_WSCLIENT_DIALOG/IDC_WSDMURCTRL1)
////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// In case MAXRECOVERYCONNECT > 0 any messagebox dialog
// can break a sequence of events, therefore I recommend
// to suppress usage error messages in this case
#define SHOWOCXERRMSG		FALSE	// Show Winsock error message from(by) ocx / otherwise by client
#define SHOWCLIENTERRMSG	FALSE	// Show any winsocket error message dialog on client
#define USE_MSGBEEP			TRUE

#define DEFAULT_HTTP_PORT		80
#define PROXY_AUTHORIZATION		_T("Proxy-authorization: basic ")
#define REGKEY_INTERNETSETTING	_T("Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings")
#define REGVAL_PROXYENABLE		_T("ProxyEnable")
#define REGVAL_PROXYSERVER		_T("ProxyServer")

typedef struct _STATE
{
	enumWsStates wsState;
	LPCTSTR lpszState;
} STATE, *LPSTATE;

/////////////////////////////////////////////////////////////////////////////
// CwsClientDlg
class CwsClientDlg : 
	public CAxDialogImpl<CwsClientDlg>,
	public IDispEventImpl<IDC_WSDMURCTRL1, CwsClientDlg,
		&DIID__DWsDmurEvents, &LIBID_WSDMURLib, 1, 0>
{
public:
	CwsClientDlg() : 
		m_spWsDmur(NULL),
		m_spProgressBar(NULL),
		m_hDefaultCursor(NULL),
		m_hWaitCursor(NULL),
		m_bProgress(FALSE),
		m_bInRecoveryConnect(FALSE),
		m_bIsFile(FALSE),
		m_bContinueDownload(FALSE),
		m_bUseMessageBeep(USE_MSGBEEP),
		m_nContentLength(0L),
		m_nTotalLengthHeaders(0L),
		m_nCurLen(0L),
		m_nLoadLen(0L),
		m_nSC(0L),
		m_nWsErr(0L),
		m_nUpLoadCount(0L),
		m_nCntRecoveryConnect(0L),
		m_nInitialFileLength(0L)
	{
	}

	~CwsClientDlg()
	{
	}

	enum { IDD = IDD_WSCLIENTDLG };

protected:
	VOID OnReceiveComplete();
	VOID SetDownLoadContinue();
	VOID AddCodeToErrList(ULONG nError, BOOL bHttpErr=TRUE);
	static STATE m_states[];
	VOID OnDataReceived(const LONG& bytesReceived, 
		const LONG& lenHeader, const LONG& UpLoadCount);
	VOID StopOperation();
	VOID SendOperation();
	CComPtr<_DWsDmur> m_spWsDmur;
	CComPtr<IProgressBar> m_spProgressBar;
	HCURSOR m_hDefaultCursor;
	HCURSOR m_hWaitCursor;
	BOOL m_bProgress;
	BOOL m_bInRecoveryConnect;
	BOOL m_bIsFile;
	BOOL m_bContinueDownload;
	BOOL m_bUseMessageBeep;
	ULONG m_nContentLength;
	ULONG m_nTotalLengthHeaders;
	ULONG m_nCurLen;
	ULONG m_nLoadLen;
	ULONG m_nSC;
	ULONG m_nWsErr;
	ULONG m_nUpLoadCount;
	ULONG m_nCntRecoveryConnect;
	ULONG m_nInitialFileLength;
	_TCHAR m_szTmpBuff[_MAX_PATH];
	CComBSTR m_bstrWsErrMsg;

public:
BEGIN_MSG_MAP(CwsClientDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_ID_HANDLER(IDC_SEND, OnSend)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	MESSAGE_HANDLER(UM_ERROR, OnError)
	COMMAND_HANDLER(IDC_ABOUT, BN_CLICKED, OnClickedAbout)
	MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CenterWindow();

		//////////////////////////////////////////////
		// Init controls

		// WsDmur control
		BOOL bIsOk = SUCCEEDED(GetDlgControl(IDC_WSDMURCTRL1,
			DIID__DWsDmur, (LPVOID*)&m_spWsDmur));
		_ASSERTE(bIsOk);
		bIsOk = SUCCEEDED(DispEventAdvise((LPUNKNOWN)m_spWsDmur));
		_ASSERTE(bIsOk);

		// ProgressBar control
		bIsOk = SUCCEEDED(GetDlgControl(IDC_PROGCTRL1,
			IID_IProgressBar, (LPVOID*)&m_spProgressBar));
		_ASSERTE(bIsOk);

		//////////////////////////////////////////////
		// Set RemoteHost & RemotePort
		ULONG RemotePort = DEFAULT_HTTP_PORT;
		BOOL bIsRemoteHost = FALSE;
		if (DEFAULT_PROXY)
		{
			// Get default proxy server
			_TCHAR szProxyServer[_MAX_PATH];
			DWORD dwProxyServer = _MAX_PATH-1;
			if (GetProxyServer(szProxyServer, dwProxyServer, RemotePort))
			{
				CComBSTR bstrProxyServer(szProxyServer); 
				m_spWsDmur->PutRemoteHost(bstrProxyServer.m_str);
				bIsRemoteHost = TRUE;
			}
		}
		if (!bIsRemoteHost)
		{
			CComBSTR bstrRemoteHost(DEFAULT_REMOTEHOST); 
			m_spWsDmur->PutRemoteHost(bstrRemoteHost.m_str);
			m_spWsDmur->PutRemotePort((long)RemotePort);
		}

		//////////////////////////////////////////
		// Set Proxy authorization
		if (USE_PROXY_AUTHORIZATION)
		{
			CComBSTR bstrHeaderEx(PROXY_AUTHORIZATION);
			bstrHeaderEx += UID_PWD;
			m_spWsDmur->PutHeaderEx(bstrHeaderEx.m_str);
		}

		//////////////////////////////////////////////
		// Show default WsDmur control properties
		//
		USES_CONVERSION;
		CComBSTR bstrProp = m_spWsDmur->GetRemoteHost();
		SetDlgItemText(IDC_REMOTEHOST, W2CT(bstrProp.m_str));
		SetDlgItemInt(IDC_REMOTEPORT, (UINT)m_spWsDmur->GetRemotePort(), FALSE);
		SetDlgItemText(IDC_MESSAGE, DEFAULT_CMDTOSEND);
		SetDlgItemText(IDC_FILENAME, LOCALFILE);

		if (CONTINUDOWNLOAD)
		{
			SetDownLoadContinue();
		}
		
		// Log-file
		bstrProp = LOGFILE;
		if (bstrProp.Length() > 0)
		{
			m_spWsDmur->PutLogFile(bstrProp.m_str);
		}

		// ShowErrMsg
		m_spWsDmur->PutShowErrMsg((VARIANT_BOOL)SHOWOCXERRMSG);

		// MaxRecoveryConnect
		m_spWsDmur->PutMaxRecoveryConnect((long)MAXRECOVERYCONNECT);

		// TimeOutRecoveryConnect
		m_spWsDmur->PutTimeOutRecoveryConnect((long)WAITRECOVERYCONNECT);
		
		// Cursors
		m_hDefaultCursor = (HCURSOR)::GetClassLong(m_hWnd, GCL_HCURSOR);
		m_hWaitCursor = ::LoadCursor(NULL, IDC_APPSTARTING); 
	
		return 1;  // Let the system set the focus
	}

	BOOL DestroyWindow()
	{
		StopOperation();
		if (m_hWaitCursor != NULL)
		{
			::DestroyCursor(m_hWaitCursor);
			m_hWaitCursor = NULL;
		}
		DispEventUnadvise((LPUNKNOWN)m_spWsDmur);
		BOOL bRetVal = CAxDialogImpl<CwsClientDlg>::DestroyWindow();
		if (bRetVal)
			::PostMessage(NULL, WM_QUIT, 0, 0);
		return bRetVal;
	}
	
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		DestroyWindow(); 
		return 0;
	}

	LRESULT OnSend(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		_TCHAR szCaption[_MAX_PATH];
		int nLen = _MAX_PATH;
		GetDlgItemText(IDC_SEND, szCaption, nLen);
		if (_tcscmp(szCaption, _T("Send")) == 0)
		{
			SendOperation();
		}
		else
		{
			StopOperation();
		}
		return 0;
	}

	LRESULT OnClickedAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		m_spWsDmur->AboutBox();
		return 0;
	}

	LRESULT OnError(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if (!SHOWCLIENTERRMSG)
			return 0;

		ULONG nCase = (ULONG)wParam;
		switch (nCase)
		{
		case 1:
			if (m_nWsErr > (ULONG)0L)
			{
				USES_CONVERSION;
				MessageBox(W2CT(m_bstrWsErrMsg.m_str), _T("CwsClientDlg::OnError():"), MB_OK|MB_ICONSTOP);
			}
			break;
		case 2:
			if (m_nSC > (ULONG)0L)
			{
				_TCHAR szMsgErr[_MAX_PATH];
				_stprintf(szMsgErr, _T("Http StatusCode %lu"), m_nSC);
				MessageBox(szMsgErr, _T("CwsClientDlg::OnError():"), MB_OK|MB_ICONSTOP);
			}
			break;
		}
		return 0;
	}

	VOID __stdcall OnSendProgress(LONG bytesSent, LONG bytesRemaining)
	{
		SetDlgItemInt(IDC_BYTESSEND, (UINT)bytesSent, FALSE);
		SetDlgItemInt(IDC_BYTESREMAINING, (UINT)bytesRemaining, FALSE);
	}

	VOID __stdcall OnDataArrival(LONG bytesReceived, LONG lenHeader, LONG UpLoadCount);
	VOID __stdcall OnStateChanged();

	BOOL GetProxyServer(LPTSTR lpszProxyServer, DWORD& dwProxyServer, ULONG& RemotePort)
	{
		BOOL bRetVal = FALSE;
		*lpszProxyServer = (_TCHAR)'\0';
		RemotePort = 0;
		CRegKey regKey;
		if (regKey.Open(HKEY_CURRENT_USER,
			REGKEY_INTERNETSETTING,
			KEY_READ) == ERROR_SUCCESS)
		{
			DWORD dwValue = 0;
			if (regKey.QueryValue(dwValue, 
				REGVAL_PROXYENABLE) == ERROR_SUCCESS)
			{
				if (dwValue != 0)
				{
					DWORD dwCount = dwProxyServer-1;
					if (regKey.QueryValue(lpszProxyServer, 
						REGVAL_PROXYSERVER, &dwCount) == ERROR_SUCCESS)
					{
						LPTSTR lpSep = _tcschr(lpszProxyServer, (_TINT)':');
						if (lpSep != NULL)
						{
							RemotePort = (ULONG)_ttol(lpSep+1);
							*lpSep = (_TCHAR)'\0';
							dwProxyServer = lpSep-lpszProxyServer;
						}
						bRetVal = TRUE;
					}
				}
			}
			regKey.Close(); 
		}

		if (!bRetVal)
		{
			RemotePort = 0;
			dwProxyServer = 0;
			*lpszProxyServer = (_TCHAR)'\0';
		}

		return bRetVal;
	}

	VOID FrmRefresh()
	{
		WPARAM wpEnabled = (WPARAM)!m_bProgress;
		SendDlgItemMessage(IDC_REMOTEHOST, WM_ENABLE, wpEnabled);
		SendDlgItemMessage(IDC_REMOTEPORT, WM_ENABLE, wpEnabled);
		SendDlgItemMessage(IDC_FILENAME, WM_ENABLE, wpEnabled);
		SendDlgItemMessage(IDC_MESSAGE, WM_ENABLE, wpEnabled);
		HWND hWndDL = GetDlgItem(IDC_CHKCONTINUEDL);
		::EnableWindow(hWndDL, !m_bProgress);
		SetDlgItemText(IDC_SEND, (m_bProgress ? _T("Stop") : _T("Send")));
		SetCursorEx(m_bProgress ? m_hWaitCursor : m_hDefaultCursor, m_bProgress);
	}

	VOID BeforeRecoveryConnect()
	{
    	// The begine RecoveryConnect state
		m_bInRecoveryConnect = TRUE;
		m_nCntRecoveryConnect = 0;
	}

	VOID AfterRecoveryConnect()
	{
		// Clear RecoveryConnect state
		m_nCntRecoveryConnect = 0;
		m_bInRecoveryConnect = FALSE;
	}

	VOID SetCursorEx(HCURSOR hCursor, BOOL bWait = FALSE)
	{
		if (hCursor == NULL)
			return ;

		HWND hWnd = NULL;
		::SetClassLong((hWnd = GetDlgItem(IDC_SEND)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_ABOUT)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDCANCEL)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_REMOTEHOST)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_REMOTEPORT)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_FILENAME)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_MESSAGE)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_CHKCONTINUEDL)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_BYTESSEND)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_BYTESREMAINING)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_RECEIVED)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_STATE)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_BYTESRECIEVED)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_UPLOADCOUNT)),
			GCL_HCURSOR, (LONG)hCursor);
		::SetClassLong((hWnd = GetDlgItem(IDC_ERRORS)),
			GCL_HCURSOR, (LONG)hCursor);
		m_spProgressBar->put_MousePointer(bWait ? 
			(MousePointerConstants)13 :
			(MousePointerConstants)0); 

		SetCursor(hCursor);
//		::SetClassLong(::GetActiveWindow(),
//			GCL_HCURSOR, (LONG)hCursor);

	}

public :
/*
BEGIN_SINK_MAP(CwsClientDlg)
	//Make sure the Event Handlers have __stdcall calling convention
	SINK_ENTRY(IDC_WSDMURCTRL1, 0x1, OnStateChanged)
	SINK_ENTRY(IDC_WSDMURCTRL1, 0x2, OnSendProgress)
	SINK_ENTRY(IDC_WSDMURCTRL1, 0x3, OnDataArrival)
END_SINK_MAP()
*/

BEGIN_SINK_MAP(CwsClientDlg)
	SINK_ENTRY_EX(IDC_WSDMURCTRL1, DIID__DWsDmurEvents, 0x1, OnStateChanged)
	SINK_ENTRY_EX(IDC_WSDMURCTRL1, DIID__DWsDmurEvents, 0x2, OnSendProgress)
	SINK_ENTRY_EX(IDC_WSDMURCTRL1, DIID__DWsDmurEvents, 0x3, OnDataArrival)
END_SINK_MAP()

	LRESULT OnSetCursor(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if (m_bProgress && m_hWaitCursor != NULL)
		{
			SetCursor(m_hWaitCursor);
		}
		else
			bHandled = FALSE;
		return 0;
	}
};

#endif //__WSCLIENTDLG_H_
